% Homework #3 from Fundamentals of Nanoelectronics, Part I
% Supriyo Datta
%
% 3.1. Capacitance: Quantum and Electrostatic
clear all

% Constants
hbar=1.06e-34;q=1.6e-19;

%Parameters
m=0.2*9.1e-31;g=2;ep=4*8.854e-12;

% mass, degeneracy factor, permittivity
kT=0.005;mu0=0.05;
% Thermal energy, equilibrium electrochemicalpotential
W=1e-6;L=1e-6;tox=2e-9;% dimensions

% Energy grid
dE=0.0001;E=[0:dE:2];NE=size(E,2);
D=(g*W*L*q*m/2/pi/hbar/hbar).*ones(1,NE);
% Density of states
M=(g*2*W/2/pi/hbar).*sqrt(2*m*q*E);% Number of modes

f0=1./(1+exp((E-mu0)./kT));
% Equilibrium Fermi function
N0=sum(dE*D.*f0);% Equilibrium electron number
U0=0*q*tox/ep/L/W;% Charging energy
alpha=0;% Drain induced barrier lowering
beta=1;% Gate effectiveness

% I-V characteristics
ii=1;dV=0.01;for V=-0.08:dV:0.08
  UL=-beta*V;ii
  change=100;U=UL;

  % Self-consistent loop
  while change>1e-6
    f1=1./(1+exp((E-mu0+U)./kT));
    f2=1./(1+exp((E-mu0+U)./kT));
    f=(f1+f2)./2;
    N=sum(dE*D.*f);% Electron number
    Unew=UL+U0*(N-N0);% Self-consistent potential
    change=abs(U-Unew);
    U=U+0.05*(Unew-U);
  end

  curr(ii)=(g*q*q*dE/2/pi/hbar)*sum(M.*(f1-f2));
  volt(ii)=V;Uscf(ii)=U;ns(ii)=N/W/L;ii=ii+1;
end

C=max(q*L*W*diff(ns)./dV)

hold on
%h=plot(volt,curr,'k');
%h=plot(volt,Uscf,'r');
h=plot(volt,ns,'r');
set(h,'linewidth',[3.0])
set(gca,'Fontsize',[40])
xlabel(' Gate Voltage (V_{g}) ---> ');
ylabel(' Electron Density (/m^{2}) ---> ');
grid on
