% Homework #3 from Fundamentals of Nanoelectronics, Part I
% Supriyo Datta
%
% 3.2. Saturation current
clear all

% Constants
hbar=1.06e-34;q=1.6e-19;

%Parameters
m=0.2*9.1e-31;g=2;ep=4*8.854e-12;
% mass, degeneracy factor, permittivity
kT=0.005;mu0=0.05;
% Thermal energy, equilibrium electrochemical potential
W=1e-6;L=1e-6;tox=2e-9;% dimensions

% Energy grid
dE=0.00001;E=[0:dE:2];NE=size(E,2);
D=(g*W*L*q*m/2/pi/hbar/hbar).*ones(1,NE);
% Density of states
M=(g*2*W/2/pi/hbar).*sqrt(2*m*q*E);% Number of modes

f0=1./(1+exp((E-mu0)./kT));
% Equilibrium Fermi function
N0=sum(dE*D.*f0);% Equilibrium electron number
U0=0*q*tox/ep/L/W;% Charging energy
alpha=0.05;% Drain induced barrier lowering

% I-V characteristics
ii=1;dV=0.01;for V=1e-3:dV:0.5
  UL=-alpha*V;ii
  change=100;U=UL;

  % Self-consistent loop
  while change>1e-6
    f1=1./(1+exp((E-mu0+U)./kT));
    f2=1./(1+exp((E-mu0+U+V)./kT));
    f=(f1+f2)./2;
    N=sum(dE*D.*f);% Electron number
    Unew=UL+U0*(N-N0);% Self-consistent potential
    change=abs(U-Unew);
    U=U+0.05*(Unew-U);
  end

  curr(ii)=(q*q*dE/2/pi/hbar)*sum(M.*(f1-f2));
  volt(ii)=V;Uscf(ii)=U;ns(ii)=N/W/L;ii=ii+1;
end

current=q*g*(4/3)*W*sqrt(2*m*q*mu0)*q*mu0/4/pi/pi/hbar/hbar;
max(curr)/current

hold on
h=plot(volt,curr,'r');
%h=plot(volt,curr,'r+');
%h=plot(volt,Uscf,'r');
%h=plot(volt,ns,'r');
set(h,'linewidth',[3.0])
set(gca,'Fontsize',[40])
xlabel(' Voltage (V_{D}) ---> ');
ylabel(' Current (A) ---> ');
grid on
