%
% plotoctaview(axes,x,y,options) --
% used to intercept plot commands and output their contents
%
function p = plotoctaview (axes,varargin)
  if (length(varargin) == 1)
    y = varargin{1};
    if (sum(imag(y)!=0) > 0)
      % plot complex vars as real vs imag
      printf("--!!plot<<imag(%s)|real(%s)|axes=%s>>\n", inputname(2), inputname(2), axes);
      printf(" %g",imag(y));
      printf(" !!x!!");
      printf(" %g",real(y));
    else
      printf("--!!plot<<%s||axes=%s>>\n", inputname(2), axes);
      printf(" %g",y);
    endif
    printf("\n!!--\n");
  else
    if (length(varargin) == 2)
      opts = "";
    else
      opts = varargin{3};
    endif
    printf("--!!plot<<%s|%s|axes=%s %s>>\n", inputname(3),inputname(2),axes,opts);
    y = varargin{2};
    if (sum(imag(y)!=0) > 0)
      % plot complex vars versus another -- show the magnitude
      printf(" %g",abs(y));
    else
      printf(" %g",y);
    endif
    printf(" !!x!!");
    printf(" %g",varargin{1});
    printf("!!--\n");
  endif

  % return some sort of plot just in case the caller tries to modify it
  p = plot(varargin{1});
endfunction
