%
% reportvars() --
% Prints out information about variables in the calling scope in a way
% that OCTAViEw can read it.  Usually called at the end of execution
% to dump the final results.
%
function reportvars()
  printf("---OCTAViEw-REPORTVARS---\n");
  v = evalin("caller","whos();");
  for i=1:length(v);
    if (strcmp(v(i).name,"ans") || regexp(v(i).name,"__.+__"))
      continue;
    endif;
    type = sprintf("%s%dx%d", v(i).class, v(i).size(1), v(i).size(2));
    if regexp(type,"^double1x[0-9]+$")
      printf("variable(%s,%s)>>", v(i).name, type);
      cmd = sprintf("if (sum(imag(%s)!=0) > 0) printf(\" %%g\",real(%s)); printf(\"<<i>>\"); printf(\" %%g\",imag(%s)); else printf(\" %%g\",%s); endif;", v(i).name, v(i).name, v(i).name, v(i).name);
      evalin("caller",cmd);
      printf("<<\n");
    endif;
  endfor;
end;
